Unit de04e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AME2E_p, DE04ED_p, DE04EM_p, DE04EP_p, DE04EQ_p, UTDE21_p;

procedure de04e(FA :Proc_F3E_DE; FI :Proc_F3E_DE; M :Integer; var JSTART :Integer;
                HMIN :Extended; EPS :Extended; P :Extended;
                var YX :Array of Extended; var X :Extended; var H :Extended;
                var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var A :Array of Extended;
                var E1 :Array of Extended; var E2 :Array of Extended;
                var E3 :Array of Extended; var W1 :Array of Extended;
                var R1 :Array of Extended; var R2 :Array of Extended;
                var R3 :Array of Extended; var R4 :Array of Extended;
                var R5 :Array of Extended; var R6 :Array of Extended;
                var YD :Array of Extended; var IERR :Integer);

implementation

procedure de04e(FA :Proc_F3E_DE; FI :Proc_F3E_DE; M :Integer; var JSTART :Integer;
                HMIN :Extended; EPS :Extended; P :Extended;
                var YX :Array of Extended; var X :Extended; var H :Extended;
                var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var A :Array of Extended;
                var E1 :Array of Extended; var E2 :Array of Extended;
                var E3 :Array of Extended; var W1 :Array of Extended;
                var R1 :Array of Extended; var R2 :Array of Extended;
                var R3 :Array of Extended; var R4 :Array of Extended;
                var R5 :Array of Extended; var R6 :Array of Extended;
                var YD :Array of Extended; var IERR :Integer);
var
I :Integer;
EPS1,XT :Extended;
BULD,BULHM :Boolean;
C :Array [0..6] of Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230;
begin
IERR := 0;
EPS1 := EPS/32.e0;
BULD := True;
BULHM := False;
if ( JSTART <>  -1 ) 
 then goto _20;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_10:
 end;
X := XP;
_20:
C[0] := 2.e0*H/3.e0;
C[1] := H/2.e0;
C[2] := H/3.e0;
C[3] := H/4.e0;
C[4] := H/6.e0;
C[5] := H/12.e0;
C[6] := 3.e0*H/4.e0;
FA(A,X + C[1],M);
AME2E(A,C[3],M,E1,R1,E2,E3);
DE04EQ(M,E1,E2);
DE04EQ(M,E2,E3);
FA(W1,X,M);
DE04ED(M,W1,A);
FI(R1,X,M);
DE04EP(M,W1,YX,R1,R5);
FI(R1,X + C[1],M);
DE04EM(M,E2,R1,R2);
for I:=1 to M do
 begin
  R2[I-1] := R2[I-1]*H;
_30:
 end;
DE04EP(M,E3,YX,R2,R3);
FA(W1,X + H,M);
DE04ED(M,W1,A);
FI(R2,X + H,M);
DE04EP(M,W1,R3,R2,R4);
for I:=1 to M do
 begin
  R4[I-1] := R4[I-1]*C[4];
_40:
 end;
for I:=1 to M do
 begin
  R3[I-1] := R1[I-1]*C[0];
_50:
 end;
DE04EP(M,E2,R3,R4,R4);
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] + R5[I-1]*C[4];
_60:
 end;
DE04EP(M,E3,R3,R4,YD);
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] + R5[I-1]*C[3];
_70:
 end;
DE04EM(M,E1,R3,R4);
FI(R3,X + C[3],M);
FA(E3,X + C[3],M);
DE04ED(M,E3,A);
DE04EP(M,E3,R4,R3,R6);
for I:=1 to M do
 begin
  R4[I-1] := R6[I-1]*C[3];
_80:
 end;
DE04EP(M,E1,YX,R4,R4);
DE04EP(M,E3,R4,R3,R3);
for I:=1 to M do
 begin
  R4[I-1] := R1[I-1]*C[5];
_90:
 end;
for I:=1 to M do
 begin
  R3[I-1] := (R6[I-1] + R3[I-1])*C[4];
_100:
 end;
DE04EP(M,E1,R3,R4,R6);
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] + R5[I-1]*C[5];
_110:
 end;
DE04EP(M,E2,R3,R6,R6);
for I:=1 to M do
 begin
  R3[I-1] := R6[I-1] + R1[I-1]*C[3];
_120:
 end;
DE04EM(M,E1,R3,R4);
FA(E3,X + C[6],M);
DE04ED(M,E3,A);
FI(R3,X + C[6],M);
DE04EP(M,E3,R4,R3,R5);
for I:=1 to M do
 begin
  R4[I-1] := R5[I-1]*C[3];
_130:
 end;
DE04EP(M,E1,R6,R4,R4);
DE04EP(M,E3,R4,R3,R3);
DE04EM(M,E1,R3,R4);
for I:=1 to M do
 begin
  R4[I-1] := R4[I-1]*C[1];
_140:
 end;
DE04EP(M,E2,R6,R4,R4);
DE04EP(M,W1,R4,R2,R2);
for I:=1 to M do
 begin
  R2[I-1] := R2[I-1]*C[5];
_150:
 end;
for I:=1 to M do
 begin
  R3[I-1] := (R5[I-1] + R3[I-1])*C[4];
_160:
 end;
DE04EP(M,E1,R3,R2,R4);
for I:=1 to M do
 begin
  R2[I-1] := R6[I-1] + R1[I-1]*C[5];
_170:
 end;
DE04EP(M,E2,R2,R4,R6);
for I:=1 to M do
 begin
  XT := (R6[I-1] - YD[I-1])/15.e0;
  R1[I-1] := XT;
  if ( Abs(R6[I-1]) >=  P ) 
   then XT := XT/Abs(R6[I-1]);
  if ( Abs(XT) >  EPS1 ) 
   then BULD := False;
  if ( Abs(XT) >=  EPS ) 
   then goto _210;
_180:
 end;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_190:
 end;
XP := X;
for I:=1 to M do
 begin
  YX[I-1] := R6[I-1];
_200:
 end;
X := X + H;
if ( BULD ) 
 then H := H*2.e0;
goto _230;
_210:
if ( BULHM ) 
 then goto _220;
H := H/2.e0;
BUL := False;
if ( Abs(H) >  Abs(HMIN) ) 
 then goto _20;
H := Sign(HMIN,H);
BULHM := True;
goto _20;
_220:
IERR := 65;
UTDE21(IERR,4);
_230:
JSTART := 1;
end;

end.
